import type { BaseContract, BigNumber, BigNumberish, BytesLike, CallOverrides, ContractTransaction, Overrides, PayableOverrides, PopulatedTransaction, Signer, utils } from "ethers";
import type { FunctionFragment, Result } from "@ethersproject/abi";
import type { Listener, Provider } from "@ethersproject/providers";
import type { TypedEventFilter, TypedEvent, TypedListener, OnEvent, PromiseOrValue } from "../../../../../common";
export type MessageStruct = {
    value: PromiseOrValue<BigNumberish>;
    sender: PromiseOrValue<string>;
    client: PromiseOrValue<string>;
    chainId: PromiseOrValue<BigNumberish>;
};
export type MessageStructOutput = [BigNumber, string, string, number] & {
    value: BigNumber;
    sender: string;
    client: string;
    chainId: number;
};
export interface IPostmanInterface extends utils.Interface {
    functions: {
        "deliverMessage((uint256,address,address,uint16),address,address,uint8,uint16)": FunctionFragment;
        "estimateFee(uint16,address,uint8,(uint256,address,address,uint16))": FunctionFragment;
        "fundPostman()": FunctionFragment;
        "setRefundTo(address)": FunctionFragment;
    };
    getFunction(nameOrSignatureOrTopic: "deliverMessage" | "estimateFee" | "fundPostman" | "setRefundTo"): FunctionFragment;
    encodeFunctionData(functionFragment: "deliverMessage", values: [
        MessageStruct,
        PromiseOrValue<string>,
        PromiseOrValue<string>,
        PromiseOrValue<BigNumberish>,
        PromiseOrValue<BigNumberish>
    ]): string;
    encodeFunctionData(functionFragment: "estimateFee", values: [
        PromiseOrValue<BigNumberish>,
        PromiseOrValue<string>,
        PromiseOrValue<BigNumberish>,
        MessageStruct
    ]): string;
    encodeFunctionData(functionFragment: "fundPostman", values?: undefined): string;
    encodeFunctionData(functionFragment: "setRefundTo", values: [PromiseOrValue<string>]): string;
    decodeFunctionResult(functionFragment: "deliverMessage", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "estimateFee", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "fundPostman", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "setRefundTo", data: BytesLike): Result;
    events: {};
}
export interface IPostman extends BaseContract {
    connect(signerOrProvider: Signer | Provider | string): this;
    attach(addressOrName: string): this;
    deployed(): Promise<this>;
    interface: IPostmanInterface;
    queryFilter<TEvent extends TypedEvent>(event: TypedEventFilter<TEvent>, fromBlockOrBlockhash?: string | number | undefined, toBlock?: string | number | undefined): Promise<Array<TEvent>>;
    listeners<TEvent extends TypedEvent>(eventFilter?: TypedEventFilter<TEvent>): Array<TypedListener<TEvent>>;
    listeners(eventName?: string): Array<Listener>;
    removeAllListeners<TEvent extends TypedEvent>(eventFilter: TypedEventFilter<TEvent>): this;
    removeAllListeners(eventName?: string): this;
    off: OnEvent<this>;
    on: OnEvent<this>;
    once: OnEvent<this>;
    removeListener: OnEvent<this>;
    functions: {
        deliverMessage(_msg: MessageStruct, _dstVautAddress: PromiseOrValue<string>, _dstPostman: PromiseOrValue<string>, _messageType: PromiseOrValue<BigNumberish>, _dstChainId: PromiseOrValue<BigNumberish>, overrides?: PayableOverrides & {
            from?: PromiseOrValue<string>;
        }): Promise<ContractTransaction>;
        estimateFee(_dstChainId: PromiseOrValue<BigNumberish>, _dstVaultAddress: PromiseOrValue<string>, _messageType: PromiseOrValue<BigNumberish>, _msg: MessageStruct, overrides?: CallOverrides): Promise<[BigNumber]>;
        fundPostman(overrides?: PayableOverrides & {
            from?: PromiseOrValue<string>;
        }): Promise<ContractTransaction>;
        setRefundTo(_refundTo: PromiseOrValue<string>, overrides?: Overrides & {
            from?: PromiseOrValue<string>;
        }): Promise<ContractTransaction>;
    };
    deliverMessage(_msg: MessageStruct, _dstVautAddress: PromiseOrValue<string>, _dstPostman: PromiseOrValue<string>, _messageType: PromiseOrValue<BigNumberish>, _dstChainId: PromiseOrValue<BigNumberish>, overrides?: PayableOverrides & {
        from?: PromiseOrValue<string>;
    }): Promise<ContractTransaction>;
    estimateFee(_dstChainId: PromiseOrValue<BigNumberish>, _dstVaultAddress: PromiseOrValue<string>, _messageType: PromiseOrValue<BigNumberish>, _msg: MessageStruct, overrides?: CallOverrides): Promise<BigNumber>;
    fundPostman(overrides?: PayableOverrides & {
        from?: PromiseOrValue<string>;
    }): Promise<ContractTransaction>;
    setRefundTo(_refundTo: PromiseOrValue<string>, overrides?: Overrides & {
        from?: PromiseOrValue<string>;
    }): Promise<ContractTransaction>;
    callStatic: {
        deliverMessage(_msg: MessageStruct, _dstVautAddress: PromiseOrValue<string>, _dstPostman: PromiseOrValue<string>, _messageType: PromiseOrValue<BigNumberish>, _dstChainId: PromiseOrValue<BigNumberish>, overrides?: CallOverrides): Promise<void>;
        estimateFee(_dstChainId: PromiseOrValue<BigNumberish>, _dstVaultAddress: PromiseOrValue<string>, _messageType: PromiseOrValue<BigNumberish>, _msg: MessageStruct, overrides?: CallOverrides): Promise<BigNumber>;
        fundPostman(overrides?: CallOverrides): Promise<void>;
        setRefundTo(_refundTo: PromiseOrValue<string>, overrides?: CallOverrides): Promise<void>;
    };
    filters: {};
    estimateGas: {
        deliverMessage(_msg: MessageStruct, _dstVautAddress: PromiseOrValue<string>, _dstPostman: PromiseOrValue<string>, _messageType: PromiseOrValue<BigNumberish>, _dstChainId: PromiseOrValue<BigNumberish>, overrides?: PayableOverrides & {
            from?: PromiseOrValue<string>;
        }): Promise<BigNumber>;
        estimateFee(_dstChainId: PromiseOrValue<BigNumberish>, _dstVaultAddress: PromiseOrValue<string>, _messageType: PromiseOrValue<BigNumberish>, _msg: MessageStruct, overrides?: CallOverrides): Promise<BigNumber>;
        fundPostman(overrides?: PayableOverrides & {
            from?: PromiseOrValue<string>;
        }): Promise<BigNumber>;
        setRefundTo(_refundTo: PromiseOrValue<string>, overrides?: Overrides & {
            from?: PromiseOrValue<string>;
        }): Promise<BigNumber>;
    };
    populateTransaction: {
        deliverMessage(_msg: MessageStruct, _dstVautAddress: PromiseOrValue<string>, _dstPostman: PromiseOrValue<string>, _messageType: PromiseOrValue<BigNumberish>, _dstChainId: PromiseOrValue<BigNumberish>, overrides?: PayableOverrides & {
            from?: PromiseOrValue<string>;
        }): Promise<PopulatedTransaction>;
        estimateFee(_dstChainId: PromiseOrValue<BigNumberish>, _dstVaultAddress: PromiseOrValue<string>, _messageType: PromiseOrValue<BigNumberish>, _msg: MessageStruct, overrides?: CallOverrides): Promise<PopulatedTransaction>;
        fundPostman(overrides?: PayableOverrides & {
            from?: PromiseOrValue<string>;
        }): Promise<PopulatedTransaction>;
        setRefundTo(_refundTo: PromiseOrValue<string>, overrides?: Overrides & {
            from?: PromiseOrValue<string>;
        }): Promise<PopulatedTransaction>;
    };
}
